'Formated with Key, Value, Sort
On Error Resume Next

'Error collection string
Dim sErrors

'overall Result
Dim bResult
	bResult = true
'aktueller Pfad
Dim sCurPath
sCurPath = CreateObject("Scripting.FileSystemObject").GetAbsolutePathName(".")

Dim strProvider
	strProvider = "Provider=MSOLAP;"
Dim strInitCatalog
	strInitCatalog = "Initial Catalog=[OCWCube];"
Dim strDataSource
	strDataSource = "Data Source=D:\MS_Cube\cymoryl_txtsrc3.cub;"
Dim strCreateCube
	strCreateCube = "CreateCube=CREATE CUBE [OCWCube] ( " & _ 
		"DIMENSION [D1], " & _ 
			"LEVEL [Alle] TYPE ALL, " & _ 
			"LEVEL [D1] OPTIONS( SORTBYNAME ), " & _ 
			"LEVEL [D11] OPTIONS( SORTBYKEY ), " & _ 
		"DIMENSION [D2], " & _ 
			"LEVEL [Alle] TYPE ALL, " & _ 
			"LEVEL [D2] OPTIONS( SORTBYNAME ), " & _ 
		"MEASURE [Summe von V1] FUNCTION SUM, " & _ 
		"MEASURE [Summe von V2] FUNCTION SUM  );"
Dim strInsertInto
	strInsertInto = "InsertInto=INSERT INTO OCWCube(" & _ 
		"[D1].[D1].KEY, " & _ 
		"[D1].[D1].NAME, " & _ 
		"[D11].KEY, " & _ 
		"[D11].NAME, " & _ 
		"[D2].[D2].KEY, " & _ 
		"[D2].[D2].NAME, " & _ 
		"[Summe von V1], " & _ 
		"[Summe von V2])  " & _ 
		"OPTIONS ATTEMPT_ANALYSIS "
Dim strSelect
	strSelect = "SELECT " & _ 
			"cub_src3.D1 as D1_KEY, " & _ 
			"cub_src3.D1 as D1_NAME, " & _ 
			"cub_src3.D11 as D11_KEY, " & _ 
			"cub_src3.D11 as D11_NAME, " & _ 
			"cub_src3.D2 as D2_KEY, " & _ 
			"cub_src3.D2 as D2_NAME, " & _ 
			"cub_src3.V1, " & _ 
			"cub_src3.V2  " & _ 
		"FROM cub_src3.csv cub_src3;"
Dim strSource_DSN
	strSource_DSN = " Source_DSN=""FileDSN=D:\MS_Cube\FDSN_D_XP.dsn"";"
Dim strUseExistingFile
	strUseExistingFile = "UseExistingFile=False"

Dim Connection
Set Connection = CreateObject("ADODB.Connection")
	Connection.Provider = "msolap.2" 
	Connection.ConnectionString = strProvider & _
		strInitCatalog & _
		strDataSource & _
		strCreateCube & _
		strInsertInto & _
		strSelect & _
		strSource_DSN & _
		strUseExistingFile
	Connection.Open

If Err.Number <> 0 Then
    sErrors = LogError(Err, sErrors)
    Err.Clear
	bResult = false
else
	Connection.Close
	Set Connection = Nothing
End If
On Error Goto 0 ' Stop looking for errors 

if bResult then
	sErrors = "Waiting 2 Seconds" & vbCrLF + "Everything is well done."
	sTitel = "Creation Info" 
	iSek = 2 'Anzeigedauer in Sekunden
	Set WshShell = WScript.CreateObject("WScript.Shell") 
	WshShell.Popup sErrors, iSek, sTitel, vbInformation
	WScript.Quit (0)
else
	sErrors = "Waiting 5 Seconds" & vbCrLF + "Errors: " & sErrors
	sTitel = "Creation Error" 
	iSek = 5 'Anzeigedauer in Sekunden
	Set WshShell = WScript.CreateObject("WScript.Shell") 
	WshShell.Popup sErrors, iSek, sTitel, vbCritical
	WScript.Quit (56)
end if

function LogError(Details, sErrors)
    Dim fs : Set fs = CreateObject("Scripting.FileSystemObject")
    Dim logFile : Set logFile = fs.OpenTextFile(sCurPath & "\cube_errors.log", 8, True)
    logFile.WriteLine(Now() & ": Error: " & Details.Number & " Details: " & Details.Description)
	LogError = sErrors & vbCrLf & ": Error: " & Details.Number & " Details: " & Details.Description
End function
