'Formated with Key, Value, Sort, Member, Set (office 2007), Formating 
On Error Resume Next

'Error collection string
Dim sErrors

'overall Result
Dim bResult
	bResult = true
'aktueller Pfad
Dim sCurPath
sCurPath = CreateObject("Scripting.FileSystemObject").GetAbsolutePathName(".")

Dim strProvider
	strProvider = "Provider=MSOLAP;"
Dim strInitCatalog
	strInitCatalog = "Initial Catalog=[OCWCube];"
Dim strDataSource
	strDataSource = "Data Source=D:\MS_Cube\cymoryl_txtsrc3.cub;"
Dim strCreateCube
	strCreateCube = "CreateCube=CREATE CUBE [OCWCube] ( " & _ 
		"DIMENSION [D1], " & _ 
			"LEVEL [Alle] TYPE ALL, " & _ 
			"LEVEL [D1] OPTIONS( SORTBYNAME ), " & _ 
			"LEVEL [D11] OPTIONS( SORTBYKEY ), " & _ 
			"LEVEL [D111] OPTIONS( SORTBYKEY ) HIDDEN , " & _ 
		"DIMENSION [D2], " & _ 
			"LEVEL [Alle] TYPE ALL, " & _ 
			"LEVEL [D2] OPTIONS( SORTBYNAME ), " & _ 
		"MEASURE [V1] FUNCTION SUM, " & _ 
		"MEASURE [V2] FUNCTION COUNT ,  " & _ 
		"COMMAND (CREATE MEMBER [OCWCube].[Measures].[C Statischer Wert als %] AS 'sum(1)', FORMAT_STRING='#0.00%'), " & _ 
		"COMMAND (CREATE MEMBER [OCWCube].[Measures].[C wie V1 als % Fett Kursiv] AS '[Measures].[V1]', FORMAT_STRING='#0.00%', FONT_FLAGS = 3 /*Bold, Italic*/, VISIBLE = 1), " & _ 
		"COMMAND (CREATE MEMBER [OCWCube].[Measures].[C Dim Count]  AS '(dimensions.count )' ), " & _
		"COMMAND (CREATE MEMBER [OCWCube].[Measures].[C D1.Level Count]  AS '([D1].Levels.count )' ), " & _
		"COMMAND (CREATE MEMBER [OCWCube].[Measures].[C Level Menber Anzahl D1.0] AS '(count([D1].Levels(0).Members))' ), " & _
		"COMMAND (CREATE MEMBER [OCWCube].[Measures].[C Level Menber Anzahl D1.1] AS '(count([D1].Levels(1).Members))' ), " & _
		"COMMAND (CREATE MEMBER [OCWCube].[Measures].[C Level Menber Anzahl D1.3] AS '(count([D1].Levels(2).Members))' ), " & _
		"COMMAND (CREATE MEMBER [OCWCube].[Measures].[C Berechnet als #0.00 Fett Kursiv und Farbe] AS '[Measures].[V1] / [Measures].[V2]', FORMAT_STRING = '#0.00', FORE_COLOR='iif([Measures].[V1]<0,RGB(255,0,0),RGB(0,0,0))', BACK_COLOR='iif([Measures].[V1]>10,RGB(0,255,0),RGB(255,255,0))'), " & _ 
		"COMMAND (CREATE SET [OCWCube].[Top 2 Count] as 'TopCount([D1].Members,2,[Measures].[V1])' /*Works at Office 2007*/), " & _
		"COMMAND (CREATE SET [OCWCube].[Top 2 Sum] as 'TopSum([D1].Members,2,[Measures].[V1])' /*Works at Office 2007*/), " & _
		"COMMAND (CREATE SET [OCWCube].[Sondergruppe aa und ac] as '{[D1].[D11].[aa], [D1].[D11].[ac]}' /*Works at Office 2007*/) " & _
		");"

Dim strInsertInto
	strInsertInto = "InsertInto=INSERT INTO OCWCube(" & _ 
		"[D1].[D1].KEY, " & _ 
		"[D1].[D1].NAME, " & _ 
		"[D11].KEY, " & _ 
		"[D11].NAME, " & _ 
		"[D111].KEY, " & _ 
		"[D111].NAME, " & _
		"[D2].[D2].KEY, " & _ 
		"[D2].[D2].NAME, " & _ 
		"[V1], " & _ 
		"[V2]) " & _ 
		" Options ATTEMPT_ANALYSIS " ' Possible Options: PASSTHROUGH, DEFER_DATA, ATTEMPT_DEFER, ATTEMPT_ANALYSIS
Dim strSelect
	strSelect = "SELECT " & _ 
			"cub_src3.D1 as D1_KEY, " & _ 
			"cub_src3.D1 as D1_NAME, " & _ 
			"cub_src3.D11 as D11_KEY, " & _ 
			"cub_src3.D11 as D11_NAME, " & _ 
			"1 as D111_KEY, " & _ 
			"1 as D111_NAME, " & _ 
			"cub_src3.D2 as D2_KEY, " & _ 
			"cub_src3.D2 as D2_NAME, " & _ 
			"cub_src3.V1, " & _ 
			"cub_src3.V2  " & _ 
		"FROM cub_src3.csv cub_src3;"
Dim strSource_DSN
	strSource_DSN = " Source_DSN=""FileDSN=D:\MS_Cube\FDSN_D_XP.dsn"";"
Dim strUseExistingFile
	strUseExistingFile = "UseExistingFile=False"

Dim Connection
Set Connection = CreateObject("ADODB.Connection")
	Connection.Provider = "msolap.2" 
	Connection.ConnectionString = strProvider & _
		strInitCatalog & _
		strDataSource & _
		strCreateCube & _
		strInsertInto & _
		strSelect & _
		strSource_DSN & _
		strUseExistingFile
	Connection.Open

If Err.Number <> 0 Then
    sErrors = LogError(Err, sErrors)
    Err.Clear
	bResult = false
else
	Connection.Close
	Set Connection = Nothing
End If
On Error Goto 0 ' Stop looking for errors 

if bResult then
	sErrors = "Waiting 2 Seconds" & vbCrLF + "Everything is well done."
	sTitel = "Creation Info" 
	iSek = 2 'Anzeigedauer in Sekunden
	Set WshShell = WScript.CreateObject("WScript.Shell") 
	WshShell.Popup sErrors, iSek, sTitel, vbInformation
	WScript.Quit (0)
else
	sErrors = "Waiting 5 Seconds" & vbCrLF + "Errors: " & sErrors
	sTitel = "Creation Error" 
	iSek = 5 'Anzeigedauer in Sekunden
	Set WshShell = WScript.CreateObject("WScript.Shell") 
	WshShell.Popup sErrors, iSek, sTitel, vbCritical
	WScript.Quit (56)
end if

function LogError(Details, sErrors)
    Dim fs : Set fs = CreateObject("Scripting.FileSystemObject")
    Dim logFile : Set logFile = fs.OpenTextFile(sCurPath & "\cube_errors.log", 8, True)
    logFile.WriteLine(Now() & ": Error: " & Details.Number & " Details: " & Details.Description)
	LogError = sErrors & vbCrLf & ": Error: " & Details.Number & " Details: " & Details.Description
End function
